osl::checkmate::ProofPieces Struct Reference

`#include <proofPieces.h>`

## Static Public Member Functions

static const PieceStand | leaf (const NumEffectState &state, Player attacker, const PieceStand max)
static const PieceStand | attack (const PieceStand prev, Move move, const PieceStand max)
static const PieceStand | defense (const CheckMoveList &moves, const NumEffectState &state, PieceStand max)

## Detailed Description

Definition at line 12 of file proofPieces.h.

## Member Function Documentation

## attack()

const PieceStand osl::checkmate::ProofPieces::attack | ( | const PieceStand | prev,
|  | Move | move,
|  | const PieceStand | max )

inline static

Definition at line 24 of file proofPieces.h.

References osl::PieceStand::add(), osl::captured(), osl::Move::capturePtype(), osl::PieceStand::get(), osl::Move::isDrop(), osl::isPiece(), osl::Move::isValid(), osl::Move::ptype(), osl::PieceStand::trySub(), and osl::unpromote().

Referenced by osl::checkmate::FixedDepthSolverExt::SetProofPieces::attack(), and osl::checkmate::Dfpn::Node::setCheckmateAttack().

## defense()

const PieceStand osl::checkmate::ProofPieces::defense | ( | const CheckMoveList & | moves,
|  | const NumEffectState & | state,
|  | PieceStand | max )

static

## leaf()

const PieceStand osl::checkmate::ProofPieces::leaf | ( | const NumEffectState & | state,
|  | Player | attacker,
|  | const PieceStand | max )

inline static

Definition at line 14 of file proofPieces.h.

References osl::checkmate::ProofPiecesUtil::addMonopolizedPieces(), osl::alt(), osl::NumEffectState::inUnblockableCheck(), and osl::SimpleState::turn().

Referenced by osl::checkmate::Dfpn::defense(), osl::checkmate::Dfpn::proofOracleDefense(), and osl::checkmate::FixedDepthSolverExt::SetProofPieces::setLeaf().

The documentation for this struct was generated from the following file:

- proofPieces.h